SystemOrganization addCategory: #'Glamour-Rubric-Presentations'!
SystemOrganization addCategory: 'Glamour-Rubric-Presentations-Examples'!

!GLMCompositePresentation methodsFor: '*glamour-rubric-presentations' stamp: 'TudorGirba 3/25/2014 15:02'!
pharoMethod
	^ self custom: GLMPharoMethodPresentation new! !

!GLMCompositePresentation methodsFor: '*glamour-rubric-presentations' stamp: 'AndreiChis 10/30/2015 14:13'!
pharoPlayground
	self deprecated: 'Use #pharoScript instead'.
	^ self custom: GLMPharoScriptPresentation new! !

!GLMCompositePresentation methodsFor: '*glamour-rubric-presentations' stamp: 'AndreiChis 10/30/2015 14:13'!
pharoScript
	^ self custom: GLMPharoScriptPresentation new! !

!GLMCompositePresentation methodsFor: '*glamour-rubric-presentations' stamp: 'AndreiChis 10/30/2015 14:04'!
rubricText
	self deprecated: 'Use #text instead'.
	^ self custom: GLMRubricTextPresentation new! !

SHTextStyler subclass: #GLMHighlighterTextParserStyler
	instanceVariableNames: 'parser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Rubric-Presentations'!

!GLMHighlighterTextParserStyler methodsFor: 'accessing' stamp: 'AndreiChis 9/2/2014 15:09'!
parser
	
	^ parser! !

!GLMHighlighterTextParserStyler methodsFor: 'accessing' stamp: 'AndreiChis 9/2/2014 15:09'!
parser: anObject
	
	parser := anObject! !

!GLMHighlighterTextParserStyler methodsFor: 'accessing' stamp: 'AndreiChis 9/2/2014 15:25'!
privateFormat: aText 
	self flag: 'This feature is not supported for now.'.
	^ aText! !

!GLMHighlighterTextParserStyler methodsFor: 'accessing' stamp: 'AndreiChis 9/2/2014 16:39'!
privateStyle: aText 
	| styledText |
	aText makeAllColor: Color red.
	styledText := self parser parse: aText asString onError: [  ].
	(styledText notNil and: [ styledText ~~ aText ]) ifTrue: [ 
		self flag: 'change only the runs array of the original text.'.
		aText setString: aText string setRunsChecking: styledText runs ]! !

RubParagraphDecorator subclass: #GLMHighlighterTextStylerDecorator
	instanceVariableNames: 'text styler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Rubric-Presentations'!

!GLMHighlighterTextStylerDecorator class methodsFor: 'querying' stamp: 'AndreiChis 4/24/2014 13:38'!
key

	^ nil! !

!GLMHighlighterTextStylerDecorator class methodsFor: 'instance creation' stamp: 'AndreiChis 9/2/2014 16:37'!
withParserStyler: aParser
	
	^ self new styler: (GLMHighlighterTextParserStyler new parser: aParser)! !

!GLMHighlighterTextStylerDecorator methodsFor: 'accessing' stamp: 'AndreiChis 9/2/2014 16:29'!
defaultStyler
	"There is no default styler"
	^ nil! !

!GLMHighlighterTextStylerDecorator methodsFor: 'accessing' stamp: 'AndreiChis 9/2/2014 16:11'!
okToStyle
	^ true! !

!GLMHighlighterTextStylerDecorator methodsFor: 'editing' stamp: 'AndreiChis 9/2/2014 15:23'!
replaceFrom: start to: stop with: aText
	self okToStyle
		ifFalse: [ ^ next replaceFrom: start to: stop with: aText ].
	self
		disableDrawingWhile: [
			aText addAttribute: self defaultFontChange.
			text ifNil: [ text := self text ].
			text replaceFrom: start to: stop with: (self styler format: aText).
			self style: text.
			next text: text.
			self recomposeFrom: start to: start + aText size - 1 delta: aText size - (stop - start + 1).
			self textArea paragraphWasComposedFrom: start to: start + aText size - 1.
			self textArea paragraphReplacedTextFrom: start to: stop with: aText ]! !

!GLMHighlighterTextStylerDecorator methodsFor: 'editing' stamp: 'AndreiChis 9/2/2014 16:25'!
style: aText
	self styler ifNotNil: [ :aStyler | aStyler styleInBackgroundProcess: aText ]! !

!GLMHighlighterTextStylerDecorator methodsFor: 'accessing' stamp: 'AndreiChis 9/2/2014 16:29'!
styler
	"The styler responsible for highlighting text in the receiver"
	^ styler ifNil: [ styler := self defaultStyler ]! !

!GLMHighlighterTextStylerDecorator methodsFor: 'accessing' stamp: 'AndreiChis 9/2/2014 16:11'!
styler: aStylerObject
	
	styler := aStylerObject.
	styler view: self! !

!GLMHighlighterTextStylerDecorator methodsFor: 'editing' stamp: 'AndreiChis 9/2/2014 15:29'!
stylerStyled: styledCopyOfText
	next ifNil: [ ^self ].
	text runs: styledCopyOfText runs.
	(self textArea scrollPane ifNil: [ self textArea ]) changed! !

!GLMHighlighterTextStylerDecorator methodsFor: 'editing' stamp: 'AndreiChis 9/2/2014 16:06'!
stylerStyledInBackground: styledCopyOfText
	next ifNil: [ ^self ].
	text string = styledCopyOfText string
		ifTrue: [ self stylerStyled: styledCopyOfText ].
! !

!GLMHighlighterTextStylerDecorator methodsFor: 'accessing' stamp: 'AndreiChis 9/2/2014 15:24'!
text
	^ next text! !

GLMTextualPresentation subclass: #GLMRubricTextPresentation
	instanceVariableNames: 'withLineNumbers withAnnotation wrapped tabWidth withColumns textSegments primarySelectionInterval'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Rubric-Presentations'!

!GLMRubricTextPresentation commentStamp: 'AndreiChis 10/1/2014 13:48' prior: 0!
A presentation that displays text using Rubric.

!

GLMRubricTextPresentation subclass: #GLMRubricHighlightedTextPresentation
	instanceVariableNames: 'editingMode font'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Rubric-Presentations'!

!GLMRubricHighlightedTextPresentation commentStamp: 'AndreiChis 9/2/2014 16:39' prior: 0!
|browser|
browser := GLMTabulator new.
browser row: #row.

browser transmit to: #row; andShow: [ :composite |
	composite custom: (GLMRubricHighlightedTextPresentation new
		editingMode: [GLMHighlighterTextRubEditingMode 
			withStylerDecorator: (RbEPersonDecorator new
				styler:  (GLMHighlighterTextParserStyler new
					parser: RbEPersonColorizer new))]) ].
	
browser openOn: '
person {	
	name	=	''Phil'';
	age = ''23'';	
}
person {}
'.!

!GLMRubricHighlightedTextPresentation methodsFor: 'accessing' stamp: 'TudorGirba 9/1/2014 11:24'!
editingMode
	^ editingMode isNil 
		ifTrue: [nil] 
		ifFalse: [editingMode glamourValue: self]! !

!GLMRubricHighlightedTextPresentation methodsFor: 'accessing' stamp: 'AndreiChis 4/22/2014 21:38'!
editingMode: aBlock
	
	editingMode := aBlock! !

!GLMRubricHighlightedTextPresentation methodsFor: 'accessing' stamp: 'TudorGirba 9/5/2014 11:05'!
font
	^ font! !

!GLMRubricHighlightedTextPresentation methodsFor: 'accessing' stamp: 'TudorGirba 9/5/2014 11:05'!
font: anObject
	font := anObject! !

!GLMRubricHighlightedTextPresentation methodsFor: 'accessing' stamp: 'TudorGirba 9/5/2014 10:51'!
morphicFont
	^ self font 
		ifNil: [ StandardFonts defaultFont  ]
		ifNotNil: [ :f | f glamourValue: self entity ]! !

!GLMRubricHighlightedTextPresentation methodsFor: 'accessing' stamp: 'AndreiChis 4/22/2014 20:48'!
renderGlamorouslyOn: aRenderer
	self registerAnnouncements.
	^ aRenderer renderRubricHighlightedTextPresentation: self! !

GLMRubricTextPresentation subclass: #GLMRubricSmalltalkCodePresentation
	instanceVariableNames: 'highlightSmalltalkContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Rubric-Presentations'!

!GLMRubricSmalltalkCodePresentation commentStamp: 'AndreiChis 10/1/2014 13:48' prior: 0!
I extend the simple Rubric text presentation with basic support for dealing with Smalltalk code.!

GLMRubricSmalltalkCodePresentation subclass: #GLMPharoMethodPresentation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Rubric-Presentations'!

!GLMPharoMethodPresentation commentStamp: 'AndreiChis 10/1/2014 13:52' prior: 0!
I provide support for displaying a Smalltalk method.

self pharoMethodPresentationExample


!

!GLMPharoMethodPresentation class methodsFor: 'examples' stamp: 'AndreiChis 10/1/2014 13:51'!
pharoMethodPresentationExample
	"
	self pharoMethodPresentationExample
	"
	
	| browser |
	browser := GLMTabulator new.
	browser
		row: #r1;
		row: #r2.
	browser transmit
		to: #r1;
		andShow: [ :aComposite | aComposite pharoMethod display: [ :method | method sourceCode ] ].
	browser transmit
		to: #r2;
		andShow: [ :aComposite | 
					aComposite pharoMethod
						display: [ :method | method sourceCode ];
						smalltalkClass: [ :method | method methodClass ] ].
	browser openOn: CompiledMethod class >> #gtExampleSimple! !

!GLMPharoMethodPresentation methodsFor: 'rendering' stamp: 'TudorGirba 5/17/2014 09:19'!
renderGlamorouslyOn: aRenderer 
	self registerAnnouncements.
	^ aRenderer renderPharoMethodPresentation: self! !

GLMRubricSmalltalkCodePresentation subclass: #GLMPharoScriptPresentation
	instanceVariableNames: 'variableBindingsBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Rubric-Presentations'!

!GLMPharoScriptPresentation commentStamp: 'AndreiChis 10/30/2015 14:16' prior: 0!
I provide support for displaying snippets of Smalltalk code  (e.g. dealing with variable binding)
!

!GLMPharoScriptPresentation class methodsFor: 'examples' stamp: 'AndreiChis 10/30/2015 14:16'!
pharoScriptPresentationExample
	"
	self pharoScriptPresentationExample
	"
	| browser |
	browser := GLMTabulator new.
	browser
		row: #r1;
		row: #r2.
	browser transmit
		to: #r1;
		andShow: [ :aComposite | 
					aComposite pharoScript
						selectionAct: [ :workspace :page | workspace evaluateSelection ] on: $d entitled: 'Do it';
						selectionAct: [ :workspace :page | workspace evaluateSelectionAndDo: [ :result | result inspect ] ]
							on: $i
							entitled: 'Inspect it';
						selectionAct: [ :workspace :page | workspace evaluateSelectionAndDo: [ :result | result explore ] ]
							on: $e
							entitled: 'Explore it' ].
	browser transmit
		to: #r2;
		andShow: [ :aComposite | 
					aComposite pharoScript
						variableBindings: [ 
							{(#browser -> browser).
							(#a -> 1)} ] ].
	browser
		openOn:
			'browser := GLMTabulator new.
browser row: #r1; row: #r2.

browser transmit to: #r1; andShow: [ :aComposite |
	aComposite pharoPlayground].
browser openOn:''self halt'' '! !

!GLMPharoScriptPresentation methodsFor: 'accessing' stamp: 'AndreiChis 3/19/2015 17:01'!
currentBindings

	self withBindingsDo: [ :bingings | ^ bingings copy ]! !

!GLMPharoScriptPresentation methodsFor: 'accessing' stamp: 'AndreiChis 9/8/2015 15:01'!
defaultSelectionActions

	^ {self goAction}, super defaultSelectionActions! !

!GLMPharoScriptPresentation methodsFor: 'actions' stamp: 'AndreiChis 9/8/2015 14:21'!
goAction
	^ GLMGenericAction new
				title: 'Do it and go';
				action: [ :t :entity |
					t highlightEvaluateAndDo: [ :result | t selection: result ] ]; 
				shortcut: $g; 
				yourself.! !

!GLMPharoScriptPresentation methodsFor: 'rendering' stamp: 'AndreiChis 10/30/2015 14:19'!
renderGlamorouslyOn: aRenderer 
	self registerAnnouncements.
	^ aRenderer renderPharoScriptPresentation: self! !

!GLMPharoScriptPresentation methodsFor: 'actions' stamp: 'AndreiChis 3/19/2015 16:32'!
resetBindings

	self withBindingsDo: [ :bindings | bindings removeAll ]! !

!GLMPharoScriptPresentation methodsFor: 'actions' stamp: 'AndreiChis 5/7/2014 18:05'!
updateVariableBindings

	self announce: (GLMVariableBindingsChanged new presentation: self).! !

!GLMPharoScriptPresentation methodsFor: 'accessing' stamp: 'AndreiChis 5/3/2014 18:38'!
variableBindings
	^ (variableBindingsBlock glamourValue: self entity) ifNil: [OrderedCollection new]! !

!GLMPharoScriptPresentation methodsFor: 'accessing' stamp: 'AndreiChis 5/3/2014 18:39'!
variableBindings: aBlock
	^ variableBindingsBlock := aBlock! !

!GLMPharoScriptPresentation methodsFor: 'actions' stamp: 'AndreiChis 3/19/2015 17:02'!
withBindingsDo: aBlock

	self announce: (GLMVariableBindingsAccessRequest new action: aBlock)! !

!GLMRubricSmalltalkCodePresentation methodsFor: 'actions browsing' stamp: 'AndreiChis 10/4/2014 23:14'!
browseIt

	self announce: (GLMTextEditorRequest for: #browseIt)! !

!GLMRubricSmalltalkCodePresentation methodsFor: 'accessing' stamp: 'AndreiChis 10/5/2014 16:48'!
browsingSelectionActions

	^ { (GLMGenericAction new) 
				title: 'Browse it';
				action: [ :aPresentation |
					aPresentation browseIt  ]; 
				shortcut: $b; 
				category: 'Code search...';
				yourself.
		(GLMGenericAction new) 
				title: 'Senders of it';
				action: [ :aPresentation |
					aPresentation sendersOfIt ]; 
				shortcut: $n; 
				category: 'Code search...';
				yourself.
		(GLMGenericAction new) 
				title: 'Implementors of it';
				action: [ :aPresentation |
					aPresentation implementorsOfIt ]; 
				shortcut: $m; 
				category: 'Code search...';
				yourself.
		(GLMGenericAction new) 
				title: 'References to it';
				action: [ :aPresentation |
					aPresentation referencesToIt ]; 
				"shortcut: $N; "
				category: 'Code search...';
				withSeparatorAfter;
				yourself.
		(GLMGenericAction new) 
				title: 'Extended string search'; 
				action: [ :aPresentation |
					aPresentation selectLine.
					self systemNavigation 
						browseMethodsWithString: aPresentation selectedText
						matchCase: false ]; 
				shortcut: $E;
				category: 'Code search...';
				yourself.
		(GLMGenericAction new) 
				title: 'Method source with it';
				action: [ :aPresentation |
					aPresentation selectLine.
					self systemNavigation 
						browseMethodsWithSourceString: aPresentation selectedText
						matchCase: false.]; 
				category: 'Code search...';
				withSeparatorAfter;
				yourself. }! !

!GLMRubricSmalltalkCodePresentation methodsFor: 'actions' stamp: 'AndreiChis 7/7/2014 10:14'!
compileTextIn: aContext from:  aSession andDo: aBlock

	self announce: (GLMCompileText new
		presentation: self;
		context: aContext;
		session: aSession;
		action: aBlock)! !

!GLMRubricSmalltalkCodePresentation methodsFor: 'actions' stamp: 'AndreiChis 5/21/2014 10:38'!
debugSelection

	self announce: GLMDebugSelection! !

!GLMRubricSmalltalkCodePresentation methodsFor: 'accessing' stamp: 'AndreiChis 1/18/2016 10:50'!
defaultSelectionActions

	^ self executionSelectionActions, 
		self browsingSelectionActions,
		self codeEditingSelectionActions! !

!GLMRubricSmalltalkCodePresentation methodsFor: 'actions' stamp: 'AndreiChis 3/19/2015 17:44'!
evaluateSelection

	self announce: (GLMEvaluateSelection new 
		action: [ :result | result ];
		makeSyncronous)! !

!GLMRubricSmalltalkCodePresentation methodsFor: 'actions' stamp: 'AndreiChis 5/3/2014 18:37'!
evaluateSelectionAndDo: aBlock

	self announce: (GLMEvaluateSelection new action: aBlock)! !

!GLMRubricSmalltalkCodePresentation methodsFor: 'accessing' stamp: 'TudorGirba 3/2/2016 16:59'!
executionSelectionActions

	^ { 
		(GLMGenericAction new) 
				title: 'Do it';
				action: [ :aPresentation |
					aPresentation highlightEvaluateAndDo: [ :result | ] ]; 
				keymap: PharoShortcuts current doItShortcut; 
				icon: GLMUIThemeExtraIcons glamorousSpawn;
				yourself.
		(GLMGenericAction new) 
				title: 'Print it';
				action: [ :aPresentation |
					aPresentation printSelection ]; 
				keymap: PharoShortcuts current printItShortcut; 
				yourself.
		(GLMGenericAction new) 
				title: 'Inspect it'; 
				action: [ :aPresentation |
					aPresentation highlightEvaluateAndDo: [ :result | result inspect ] ]; 
				keymap: PharoShortcuts current inspectItShortcut; 
				icon: GLMUIThemeExtraIcons glamorousInspect;
				yourself.
		(GLMGenericAction new) 
				title: 'Basic Inspect it'; 
				action: [ :aPresentation |
					aPresentation highlightEvaluateAndDo: [ :result | result basicInspect ] ]; 
				shortcut: $I; 
				icon: GLMUIThemeExtraIcons glamorousInspect;
				yourself.
		(GLMGenericAction new) 
				title: 'Debug it'; 
				action: [ :aPresentation |
					aPresentation debugSelection ]; 
				shortcut: $D;
				yourself.
		(GLMGenericAction new) 
				title: 'Profile it'; 
				action: [ :aPresentation |
					aPresentation profileSelection ]; 
				withSeparatorAfter;
				yourself.
		 }! !

!GLMRubricSmalltalkCodePresentation methodsFor: 'actions' stamp: 'AndreiChis 1/14/2015 11:02'!
highlightEvaluateAndDo: aBlock

	self announce: (GLMHighlightAndEvaluate new action: aBlock)! !

!GLMRubricSmalltalkCodePresentation methodsFor: 'accessing' stamp: 'AndreiChis 4/28/2016 11:04'!
highlightSmalltalkContext
	^ highlightSmalltalkContext isNil 
		ifTrue: [nil] 
		ifFalse: [highlightSmalltalkContext glamourValue: self entity]! !

!GLMRubricSmalltalkCodePresentation methodsFor: 'actions browsing' stamp: 'AndreiChis 10/4/2014 23:14'!
implementorsOfIt

	self announce: (GLMTextEditorRequest for: #implementorsOfIt)! !

!GLMRubricSmalltalkCodePresentation methodsFor: 'rendering' stamp: 'AndreiChis 5/20/2014 17:32'!
installDefaultSelectionActions

	self defaultSelectionActions do: [ :anAction |
		self addSelectionAction: anAction ]! !

!GLMRubricSmalltalkCodePresentation methodsFor: 'actions' stamp: 'AndreiChis 5/21/2014 10:38'!
printSelection

	self announce: GLMPrintSelection! !

!GLMRubricSmalltalkCodePresentation methodsFor: 'actions' stamp: 'AndreiChis 5/21/2014 10:38'!
profileSelection

	self announce: GLMProfileSelection! !

!GLMRubricSmalltalkCodePresentation methodsFor: 'actions browsing' stamp: 'AndreiChis 10/4/2014 23:14'!
referencesToIt

	self announce: (GLMTextEditorRequest for: #referencesToIt)! !

!GLMRubricSmalltalkCodePresentation methodsFor: 'actions browsing' stamp: 'AndreiChis 10/4/2014 23:14'!
sendersOfIt

	self announce: (GLMTextEditorRequest for: #sendersOfIt)! !

!GLMRubricSmalltalkCodePresentation methodsFor: 'accessing' stamp: 'AndreiChis 4/28/2016 11:04'!
smalltalkClass: aBlock
	"aBlock takes as parameters the entity objects and 
	its evaluation is expected to produce a Smalltalk class"
	highlightSmalltalkContext := aBlock.! !

!GLMRubricTextPresentation methodsFor: 'accessing' stamp: 'AlainPlantec 8/2/2013 20:45'!
addTextSegment: aTextSegmentMorph
	self textSegments add: aTextSegmentMorph! !

!GLMRubricTextPresentation methodsFor: 'actions text' stamp: 'AndreiChis 1/13/2016 11:49'!
clearUserEdits
	self flag: 'Should remove the need for using #defer:. Currently it used as
	the rendered suspends all announcements for a presentation when it handles a text changed request.'.
	UIManager default defer: [ 
		self announce: (GLMTextEditorRequest new 
			action: [ :anEditor | anEditor model clearUserEdits]) ]! !

!GLMRubricTextPresentation methodsFor: 'accessing' stamp: 'StephaneDucasse 10/12/2016 21:40'!
codeEditingSelectionActions
	
	^ { 
		(GLMGenericAction new) 
				title: 'Cut'; 
				action: [ :aPresentation |
					aPresentation cut ]; 
				iconName: #smallCutIcon;
				shortcut: $x; 
				withSeparatorBefore;
				yourself.
		(GLMGenericAction new) 
				title: 'Copy';
				action: [ :aPresentation |
					aPresentation copySelection ]; 
				iconName: #smallCopyIcon;
				shortcut: $c; 
				yourself.
		(GLMGenericAction new) 
				title: 'Paste';
				action: [ :aPresentation |
					aPresentation paste ]; 
				iconName: #smallPasteIcon;
				shortcut: $v; 
				yourself.
		(GLMGenericAction new) 
				title: 'Paste...';
				action: [ :aPresentation |
					aPresentation pasteRecent  ]; 
				iconName: #smallCopyIcon;
				withSeparatorAfter;
				yourself. }! !

!GLMRubricTextPresentation methodsFor: 'actions text' stamp: 'AndreiChis 10/4/2014 22:35'!
copySelection

	self announce: (GLMTextEditorRequest for: #copySelection)! !

!GLMRubricTextPresentation methodsFor: 'actions text' stamp: 'AndreiChis 10/3/2014 18:50'!
cut

	self announce: (GLMTextEditorRequest for: #cut)! !

!GLMRubricTextPresentation methodsFor: 'accessing' stamp: 'AndreiChis 10/5/2014 15:04'!
defaultSelectionActions

	^ self executionSelectionActions
	! !

!GLMRubricTextPresentation methodsFor: 'actions text' stamp: 'AndreiChis 1/18/2016 10:55'!
flash

	self announce: (GLMTextEditorRequest new 
		action: [ :anEditor | anEditor flash])! !

!GLMRubricTextPresentation methodsFor: 'actions text' stamp: 'AndreiChis 1/18/2016 10:55'!
hasUnacceptedEdits

	self announce: (GLMTextEditorRequest new 
		action: [ :anEditor | ^ anEditor model hasUnacceptedEdits])! !

!GLMRubricTextPresentation methodsFor: 'actions text' stamp: 'AndreiChis 10/4/2014 22:35'!
paste

	self announce: (GLMTextEditorRequest for: #paste)! !

!GLMRubricTextPresentation methodsFor: 'actions text' stamp: 'AndreiChis 10/4/2014 22:36'!
pasteRecent

	self announce: (GLMTextEditorRequest for: #pasteRecent)! !

!GLMRubricTextPresentation methodsFor: 'accessing' stamp: 'AlainPlantec 9/18/2013 21:59'!
primarySelectionInterval
	^ primarySelectionInterval! !

!GLMRubricTextPresentation methodsFor: 'accessing' stamp: 'AlainPlantec 9/18/2013 21:59'!
primarySelectionInterval: anInterval
	primarySelectionInterval := anInterval! !

!GLMRubricTextPresentation methodsFor: 'rendering' stamp: 'TudorGirba 6/2/2013 21:38'!
renderGlamorouslyOn: aRenderer
	self registerAnnouncements.
	^ aRenderer renderRubricTextPresentation: self! !

!GLMRubricTextPresentation methodsFor: 'accessing' stamp: 'AlainPlantec 9/18/2013 22:15'!
scrollAtIndex: anIndex
	self primarySelectionInterval: (anIndex to: anIndex - 1)! !

!GLMRubricTextPresentation methodsFor: 'accessing' stamp: 'AlainPlantec 8/2/2013 16:57'!
tabWidth
	^ tabWidth ifNil: [ TextStyle default rubTabWidth ]! !

!GLMRubricTextPresentation methodsFor: 'accessing' stamp: 'AlainPlantec 8/2/2013 16:56'!
tabWidth: anInteger
	tabWidth := anInteger! !

!GLMRubricTextPresentation methodsFor: 'accessing' stamp: 'AlainPlantec 8/2/2013 19:15'!
textSegments
	^textSegments ifNil: [ textSegments := OrderedCollection new ]! !

!GLMRubricTextPresentation methodsFor: 'accessing' stamp: 'AlainPlantec 8/2/2013 16:43'!
withAnnotation
	
	^ withAnnotation ifNil: [ withAnnotation := false ]! !

!GLMRubricTextPresentation methodsFor: 'accessing' stamp: 'AlainPlantec 8/2/2013 16:43'!
withAnnotation: aBoolean
	
	withAnnotation := aBoolean! !

!GLMRubricTextPresentation methodsFor: 'accessing' stamp: 'AlainPlantec 8/2/2013 18:21'!
withColumns
	
	^ withColumns ifNil: [ withColumns := false ]! !

!GLMRubricTextPresentation methodsFor: 'accessing' stamp: 'AlainPlantec 8/2/2013 18:21'!
withColumns: aBoolean
	
	withColumns := aBoolean! !

!GLMRubricTextPresentation methodsFor: 'accessing' stamp: 'AlainPlantec 8/2/2013 16:38'!
withLineNumbers
	
	^ withLineNumbers ifNil: [ withLineNumbers := false ]! !

!GLMRubricTextPresentation methodsFor: 'accessing' stamp: 'AlainPlantec 8/2/2013 16:38'!
withLineNumbers: aBoolean
	
	withLineNumbers := aBoolean! !

!GLMRubricTextPresentation methodsFor: 'accessing' stamp: 'AlainPlantec 8/2/2013 19:15'!
withTextSegments: aCollection
	self textSegments addAll: aCollection! !

!GLMRubricTextPresentation methodsFor: 'accessing' stamp: 'AlainPlantec 8/2/2013 16:48'!
wrapped
	
	^  wrapped ifNil: [ wrapped := true ]! !

!GLMRubricTextPresentation methodsFor: 'accessing' stamp: 'AlainPlantec 8/2/2013 16:45'!
wrapped: aBoolean
	
	wrapped := aBoolean! !

RubEditingMode subclass: #GLMHighlighterTextRubEditingMode
	instanceVariableNames: 'stylerDecorator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Rubric-Presentations'!

!GLMHighlighterTextRubEditingMode class methodsFor: 'instance creation' stamp: 'AndreiChis 9/11/2014 15:17'!
withParserStyler: aParser

	^ self new stylerDecorator: (GLMHighlighterTextStylerDecorator
			withParserStyler: aParser)! !

!GLMHighlighterTextRubEditingMode class methodsFor: 'instance creation' stamp: 'AndreiChis 9/2/2014 16:13'!
withStylerDecorator: aDecorator

	^ self new stylerDecorator: aDecorator! !

!GLMHighlighterTextRubEditingMode methodsFor: 'accessing' stamp: 'AndreiChis 9/2/2014 16:13'!
stylerDecorator
	
	^ stylerDecorator! !

!GLMHighlighterTextRubEditingMode methodsFor: 'accessing' stamp: 'AndreiChis 9/2/2014 16:13'!
stylerDecorator: anObject
	
	stylerDecorator := anObject! !

!GLMHighlighterTextRubEditingMode methodsFor: 'initialize-release' stamp: 'TudorGirba 9/1/2014 15:26'!
updateTextAreaWhenPlugged
	self withStyler.
	super updateTextAreaWhenPlugged! !

!GLMHighlighterTextRubEditingMode methodsFor: 'initialize-release' stamp: 'TudorGirba 9/1/2014 15:26'!
updateTextAreaWhenUnplugged
	self withoutStyler.
	super updateTextAreaWhenUnplugged

! !

!GLMHighlighterTextRubEditingMode methodsFor: 'initialize-release' stamp: 'AndreiChis 9/2/2014 16:13'!
withStyler
	self textArea withDecorator: self stylerDecorator! !

!GLMHighlighterTextRubEditingMode methodsFor: 'initialize-release' stamp: 'AndreiChis 9/2/2014 16:13'!
withoutStyler
	self textArea withoutDecorator: self stylerDecorator! !

Model subclass: #GLMRubricExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Rubric-Presentations-Examples'!

GLMRubricExample subclass: #GLMLipsumWithSegmentsExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Rubric-Presentations-Examples'!

!GLMLipsumWithSegmentsExample commentStamp: '<historical>' prior: 0!
self new open!

!GLMLipsumWithSegmentsExample methodsFor: 'accessing' stamp: 'StephaneDucasse 9/23/2016 21:53'!
presentation
	^ GLMCompositePresentation new
		with: [ :a | 
			| t seg |
			t := a text.
"			t withLineNumbers: true.
			t withAnnotation: true.
			t wrapped: true.
			t tabWidth: 40.
			t withColumns: true.
"			
			seg := RubUnderlinedSegmentMorph from: 1 to: 29.
			seg icon: (self iconNamed: #smallErrorIcon).
			seg label: 'Please review'.
			seg iconBlock: [ :segment :event | segment delete ].
			t addTextSegment: seg.
			
			seg := RubPlainSegmentMorph from: 535 to: 659.
			seg color: (Color green alpha: 0.3).
			seg icon: (self iconNamed: #smallErrorIcon).
			seg label: 'Remove'.
			seg
				iconBlock: [ :segment :event | 
					segment textArea selectFrom: segment firstIndex to: segment lastIndex.
					segment textArea replaceSelectionWith: ''.
					segment delete ].
			t addTextSegment: seg.
			seg := RubUnderlinedSegmentMorph from: 1000 to: 1030.
			seg icon: (self iconNamed: #smallHelpIcon).
			seg label: 'Print it'.
			seg iconBlock: [ :segment :event | Transcript show: segment getText ].
			t addTextSegment: seg]! !

!GLMRubricExample methodsFor: 'accessing' stamp: 'AlainPlantec 8/2/2013 22:25'!
iconProvider
	" For 2.0/3.0 compatibility "
	^ (Smalltalk respondsTo: #ui)
		ifTrue: [ (Smalltalk perform: #ui) icons]
		ifFalse: [ UITheme current ]! !

!GLMRubricExample methodsFor: 'accessing' stamp: 'SvenVanCaekenberghe 12/4/2014 21:31'!
loremIpsum
	^ String loremIpsum: 81233! !

!GLMRubricExample methodsFor: 'opening' stamp: 'AlainPlantec 8/2/2013 22:25'!
open
	self presentation openOn: self loremIpsum ! !

GLMRubricExample subclass: #GLMSegmentWithHelpAndMouseUpActionExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Rubric-Presentations-Examples'!

!GLMSegmentWithHelpAndMouseUpActionExample commentStamp: '<historical>' prior: 0!
self new open!

!GLMSegmentWithHelpAndMouseUpActionExample methodsFor: 'accessing' stamp: 'AndreiChis 10/23/2015 17:07'!
presentation
	^ GLMCompositePresentation new
		with: [ :a | 
			| t seg |
			t := a text.
			seg := RubPlainSegmentMorph from: 400 to: 746.
			seg color: (Color green alpha: 0.3).
			seg setBalloonText: 'This sentence should be removed. Click on it to remove it'.
			seg
				when: #mouseDown
				send: #value
				to: [ 
					seg textArea selectFrom: seg firstIndex to: seg lastIndex.
					seg textArea replaceSelectionWith: ''.
					seg delete ].
			t addTextSegment: seg ]! !

GLMRubricExample subclass: #GLMSimpleRubricExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Rubric-Presentations-Examples'!

!GLMSimpleRubricExample commentStamp: '<historical>' prior: 0!
self new open!

!GLMSimpleRubricExample methodsFor: 'accessing' stamp: 'AndreiChis 10/23/2015 17:07'!
presentation
	^ GLMCompositePresentation new
		with: [ :a | 
			| t seg |
			t := a text.
			t withLineNumbers: true.
			t withAnnotation: true.
			t wrapped: true.
			t tabWidth: 40.
			t withColumns: true]! !
